import { useWebSocket, useBrowserLocation } from '@vueuse/core'

const location = useBrowserLocation()
let origin = 'ws://localhost:3000'

if (location && location.value.origin) {
  origin = location.value.origin.replace(/^http/, 'ws')
}

const { status, data, send, open, close } = useWebSocket(origin, {
  autoReconnect: true,
  immediate: false,
  autoClose: false,
})

export default function connectWebsocket() {
  return {
    status,
    data,
    send,
    open,
    close,
  }
}
