import { resolve } from 'path'
const vueCompositionAPIFullpath = resolve(
  './node_modules/@vue/composition-api/dist/vue-composition-api.mjs'
)

export default {
  // Global page headers: https://go.nuxtjs.dev/config-head
  head: {
    title: 'ooc-app',
    htmlAttrs: {
      lang: 'en',
    },
    meta: [
      { charset: 'utf-8' },
      { name: 'viewport', content: 'width=device-width, initial-scale=1' },
      { hid: 'description', name: 'description', content: '' },
      { name: 'format-detection', content: 'telephone=no' },
    ],
    link: [{ rel: 'icon', type: 'image/x-icon', href: '/favicon.ico' }],
  },

  // Global CSS: https://go.nuxtjs.dev/config-css
  css: [],

  // Plugins to run before rendering page: https://go.nuxtjs.dev/config-plugins
  plugins: [],

  // Auto import components: https://go.nuxtjs.dev/config-components
  components: true,

  // Modules for dev and build (recommended): https://go.nuxtjs.dev/config-modules
  buildModules: [
    // https://go.nuxtjs.dev/eslint
    '@nuxtjs/eslint-module',
    '@vueuse/nuxt',
  ],

  // Modules: https://go.nuxtjs.dev/config-modules
  modules: ['~/modules/ws-server'],

  // Build Configuration: https://go.nuxtjs.dev/config-build
  alias: {
    '@vue/composition-api$':
      '@vue/composition-api/dist/vue-composition-api.mjs',
    '@vue/composition-api/dist/vue-composition-api.mjs':
      vueCompositionAPIFullpath,
  },
  build: {
    postcss: null,
    extend(config) {
      config.module.rules.push({
        test: /\.mjs$/,
        include: /node_modules/,
        type: 'javascript/auto',
      })
    },
  },
}
